SystemOrganization addCategory: #'GBT-DSL_LittleCompany'!

Object subclass: #HelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!HelloWorld class methodsFor: 'example' stamp: 'hk 11/1/2016 13:54'!
example
	GbtStore initialize. GbtSVO initialize.
	(GbtThingEditor on: self hello) openWithSpec! !

!HelloWorld class methodsFor: 'things' stamp: 'hk 5/12/2016 17:09'!
hello
	^GbtThing newStruct: 'hello' define: {
		{ #summary . 'Hello #yourName'}	.
		{ #yourName . #val: . ''}	}! !

Object subclass: #Invoices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Invoices class methodsFor: 'example' stamp: 'hk 11/7/2016 19:19'!
exampleRun
	GbtStore initialize. GbtSVO initialize.
	(self invoicesContext: '') ui title: #Invoices; open! !

!Invoices class methodsFor: 'things' stamp: 'hk 6/22/2016 17:03'!
invoice
	^GbtThing newStruct: 'Invoice' define: {
		{ #date . #date: . Date today}.
		{ #Sum . #sum: .  #tprice}.
		{ #VAT . #calc: .  '0.19 * #Sum'}.
		{ #totals . #calc: .  '#VAT + #Sum'}.
		{ #items . #listOf: . LittleCompany product}.					
	} full: { 
		{ #customer . #thing: . Rolodex contact}.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 11/7/2016 19:25'!
invoiceContext: userName 
	^GbtPlainAC newStruct: 'Invoice'  for: userName define: {
		{#displayAs: . 'Invoice'  } .
		{#uiSpec:icon: . #GbtDiItemUI . #invoices}.
	"integration with other contexts in these 2 lines:"
		{#chooseFor:with: . #customer . Rolodex rolodex: userName }.
		{#chooseFor:with: . #items . LittleCompany productsContext: userName }.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 11/7/2016 19:19'!
invoicesContext: userName  
	^GbtBigListAC newStruct: 'Invoices'  for: userName define: {
		{#displayAs: . 'Invoices'} .
		{#uiSpec:icon: . #GbtListUI . #invoicing} .
		{#templates: . self invoice} .
		{#display: . #(firstName lastName company date Sum VAT totals)} .
		{#subcontext: . self invoiceContext: userName} }! !

Object subclass: #LittleCompany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!LittleCompany class methodsFor: 'example' stamp: 'hk 11/6/2016 15:59'!
exampleRun
	GbtStore initialize. GbtSVO initialize.
	self login open! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 11/15/2016 16:00'!
littleCompany: userName  
	"self littleCompany" 

	^GbtPlainAC newStruct: 'LittleCompany'  for: userName define: {
		{#aspect:on: . LittleCompany productsContext: userName . nil  } .
		{#aspect:on: . Rolodex rolodex: userName . nil  } .
		{#aspect:on: . Invoices invoicesContext: userName . nil } .		
		{#uiSpec:icon: . #GbtMainUI . #main} }! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 11/8/2016 20:13'!
login
	^ GbtLoginAC newStruct: 'LittleCompanyLogin' for: '' define:
			{{#displayAs: . #'Little Company'}.
			{#appClass:selector: . #LittleCompany . #littleCompany:}.
			{#legalText: . 'GloConn International © 2016'}}! !

!LittleCompany class methodsFor: 'things' stamp: 'hk 11/10/2016 12:50'!
product
	^GbtThing newStruct: 'Product' define: { 
		{ #summary .  '#amount pc à #price € = #total € . #description'}.		
		{ #idNumberPolicy . #BizIdPolicy }.
		{ #description . #val: . ''}.		
		{ #amount . #val: . ''}.
		{ #price . #val: . ''}.	
		{ #total . #calc:tag: . '#amount * #price' . #tprice }} ! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 11/7/2016 17:14'!
productContext: userName  
	^GbtPlainAC newStruct: 'ProductContext'  for: userName define: {
		{#displayAs: . 'Product'  } .
		{#uiSpec:icon: . #GbtDiItemUI . #taskOrders}}! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 11/14/2016 18:07'!
productsContext: userName  
	^GbtBigListAC newStruct: 'ProductsContext'  for: userName define: {
		{#displayAs: . 'Products'} .
		{#uiSpec:icon: . #GbtListUI . #taskOrders} .
		{#templates: . self product} .
		{#loadPolicy: . #simpleload } .
		{#display: . #( price amount total description)} .
		{#noPolicyPrefix: . 'Prod'}.
		{#subcontext: . self productContext: userName} }! !

Object subclass: #Rolodex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Rolodex class methodsFor: 'things' stamp: 'hk 5/12/2016 17:01'!
address
	^GbtThing newStruct: 'Address' define: { 
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityName . #val: . ''}.	
		{ #cityCode . #val: . ''}} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 5/12/2016 17:06'!
contact
	^GbtThing newStruct: 'Contact' define: {
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #company . #val: . ''}.					
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } .
	} full: { 
		{ #address .  #thing: . self address}.
	}! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 11/7/2016 17:16'!
contactContext: userName  
	self labelDeclarative .
	^GbtPlainAC newStruct: 'ContactContext'  for: userName define: {
		{#displayAs: . 'Contacts'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
		{#menu: . #'print label' }.
		{#behavior:actions: . #'print label' . #(COMPOSE LabelDeclarative TOPDF #(etikett pdfSlots) )}}! !

!Rolodex class methodsFor: 'example' stamp: 'hk 11/7/2016 19:25'!
exampleRun
	GbtStore initialize. GbtSVO initialize.
	(self rolodex: '') ui title: #Rolodex; open! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 5/18/2016 16:22'!
labelDeclarative
	^GbtDeclarative newStruct: 'LabelDeclarative' define: { 
		{ #pdfSlots . #decl: . self pdfSlots }.
		{ #firstName }.		
		{ #lastName }.
		{ #address }} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 5/17/2016 19:57'!
labelSticker
	^GbtThing newStruct: 'Label' define: { 
		{ #nameLine . #ref: . '#firstName #lastName'}.		
		{ #streetLine . #ref: . '#streetNo , #street'}.
		{ #cityLine . #ref: . '#cityCode #cityName' }} ! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 5/17/2016 20:00'!
pdfSlots
	^GbtDeclarative newStruct: 'pdfSlots' define: { 
		{ #nameLine }.		
		{ #streetLine }.
		{ #cityLine }} ! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 11/7/2016 19:25'!
rolodex: userName  
	^GbtBigListAC newStruct: 'Rolodex'  for: userName define: {
		{#displayAs: . 'Rolodex'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self contact} .
		{#loadPolicy: . #autoload } .
		{#display: . #(firstName lastName company cityName)} .
		{#subcontext: . self contactContext: userName}.
		{#poolThings: . {self labelSticker} }}! !
